"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.regexp.split");

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.for-each");

var _object = _interopRequireDefault(require("object.entries"));

var _express = _interopRequireDefault(require("express"));

var _path = _interopRequireDefault(require("path"));

var _splitByLastDot = _interopRequireDefault(require("./helpers/splitByLastDot"));

var _isConstrutor = _interopRequireDefault(require("./helpers/isConstrutor"));

var cwd = process.cwd();

var mapRoutes = function mapRoutes(routes, pathToController) {
  var router = _express.default.Router();

  var requestMethodPath;
  var requestMethod;
  var controllerMethod;
  var controller;
  var contr;
  var handler;
  var myPath;

  var myPathToController = _path.default.join(cwd, pathToController);

  var routesArr = (0, _object.default)(routes);
  routesArr.forEach(function (value) {
    requestMethodPath = value[0].replace(/\s\s+/g, ' ');
    requestMethod = requestMethodPath.split(' ')[0].toLocaleLowerCase();
    myPath = requestMethodPath.split(' ')[1];
    controller = (0, _splitByLastDot.default)(value[1])[0];
    controllerMethod = (0, _splitByLastDot.default)(value[1])[1];

    try {
      handler = require("".concat(myPathToController).concat(controller)).default;
      var isConstructable = (0, _isConstrutor.default)(handler);

      if (isConstructable) {
        contr = new handler();
      } else {
        contr = handler();
      }
    } catch (err) {
      require('@babel/register');

      handler = require("".concat(myPathToController).concat(controller));
      contr = new handler();
    }

    router.route(myPath)[requestMethod](contr[controllerMethod]);
  });
  return router;
};

var _default = mapRoutes;
exports.default = _default;